<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.util.genarr;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.util.List;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    public class GenericDynamicArray&lt;T&gt; extends AbstractGenericArray&lt;T&gt; implements CloneableTyped&lt;GenericDynamicArray&lt;T&gt;&gt; {<a name="line.38"></a>
<FONT color="green">039</FONT>            <a name="line.39"></a>
<FONT color="green">040</FONT>            @SuppressWarnings("unchecked")<a name="line.40"></a>
<FONT color="green">041</FONT>            public static &lt;T&gt; GenericDynamicArray empty() {<a name="line.41"></a>
<FONT color="green">042</FONT>                    return new GenericDynamicArray&lt;T&gt;((T[])EMPTY);<a name="line.42"></a>
<FONT color="green">043</FONT>            }<a name="line.43"></a>
<FONT color="green">044</FONT>            <a name="line.44"></a>
<FONT color="green">045</FONT>            private static final int DEFAULT_CAPACITY = 7;<a name="line.45"></a>
<FONT color="green">046</FONT>            <a name="line.46"></a>
<FONT color="green">047</FONT>            private int     mLength = 0;<a name="line.47"></a>
<FONT color="green">048</FONT>            private T[]     mArray;<a name="line.48"></a>
<FONT color="green">049</FONT>    <a name="line.49"></a>
<FONT color="green">050</FONT>            public GenericDynamicArray() {<a name="line.50"></a>
<FONT color="green">051</FONT>                    this(DEFAULT_CAPACITY);<a name="line.51"></a>
<FONT color="green">052</FONT>            }<a name="line.52"></a>
<FONT color="green">053</FONT>            <a name="line.53"></a>
<FONT color="green">054</FONT>            @SuppressWarnings("unchecked")<a name="line.54"></a>
<FONT color="green">055</FONT>            public GenericDynamicArray(int initialCapacity) {<a name="line.55"></a>
<FONT color="green">056</FONT>                    mArray = initialCapacity == 0 ? (T[])EMPTY : newArray(initialCapacity);<a name="line.56"></a>
<FONT color="green">057</FONT>                    //mLength = 0<a name="line.57"></a>
<FONT color="green">058</FONT>            }<a name="line.58"></a>
<FONT color="green">059</FONT>            <a name="line.59"></a>
<FONT color="green">060</FONT>            public GenericDynamicArray(T... array) {<a name="line.60"></a>
<FONT color="green">061</FONT>                    mArray  = array;<a name="line.61"></a>
<FONT color="green">062</FONT>                    mLength = array.length;<a name="line.62"></a>
<FONT color="green">063</FONT>            }<a name="line.63"></a>
<FONT color="green">064</FONT>            <a name="line.64"></a>
<FONT color="green">065</FONT>            public GenericDynamicArray(GenericDynamicArray&lt;? extends T&gt; dynamicArray) {<a name="line.65"></a>
<FONT color="green">066</FONT>                    mArray  = dynamicArray.mArray.clone();<a name="line.66"></a>
<FONT color="green">067</FONT>                    mLength = dynamicArray.mLength;<a name="line.67"></a>
<FONT color="green">068</FONT>            }<a name="line.68"></a>
<FONT color="green">069</FONT>            public GenericDynamicArray(GenericArray&lt;? extends T&gt; genericArray) {<a name="line.69"></a>
<FONT color="green">070</FONT>                    mArray  = newArray(genericArray.length());<a name="line.70"></a>
<FONT color="green">071</FONT>                    genericArray.toArray(mArray);<a name="line.71"></a>
<FONT color="green">072</FONT>                    mLength = genericArray.length();<a name="line.72"></a>
<FONT color="green">073</FONT>            }<a name="line.73"></a>
<FONT color="green">074</FONT>            <a name="line.74"></a>
<FONT color="green">075</FONT>            public GenericDynamicArray(Iterable&lt;? extends T&gt; iterable) {<a name="line.75"></a>
<FONT color="green">076</FONT>                    this();<a name="line.76"></a>
<FONT color="green">077</FONT>                    addAll(iterable);<a name="line.77"></a>
<FONT color="green">078</FONT>            }<a name="line.78"></a>
<FONT color="green">079</FONT>            <a name="line.79"></a>
<FONT color="green">080</FONT>            @Override<a name="line.80"></a>
<FONT color="green">081</FONT>            public int length() {<a name="line.81"></a>
<FONT color="green">082</FONT>                    return mLength;<a name="line.82"></a>
<FONT color="green">083</FONT>            }<a name="line.83"></a>
<FONT color="green">084</FONT>            public int capacity() {<a name="line.84"></a>
<FONT color="green">085</FONT>                    return mArray.length;<a name="line.85"></a>
<FONT color="green">086</FONT>            }<a name="line.86"></a>
<FONT color="green">087</FONT>            <a name="line.87"></a>
<FONT color="green">088</FONT>            public void trimToLength() {<a name="line.88"></a>
<FONT color="green">089</FONT>                    trim(false);<a name="line.89"></a>
<FONT color="green">090</FONT>            }<a name="line.90"></a>
<FONT color="green">091</FONT>            public void trimToNonNull() {<a name="line.91"></a>
<FONT color="green">092</FONT>                    trim(true);<a name="line.92"></a>
<FONT color="green">093</FONT>            }<a name="line.93"></a>
<FONT color="green">094</FONT>    <a name="line.94"></a>
<FONT color="green">095</FONT>            private void trim(boolean nonNull) {<a name="line.95"></a>
<FONT color="green">096</FONT>                    int len = length();<a name="line.96"></a>
<FONT color="green">097</FONT>                    if (nonNull) {<a name="line.97"></a>
<FONT color="green">098</FONT>                            while (len - 1 &gt;= 0 &amp;&amp; mArray[len - 1] == null) len--;<a name="line.98"></a>
<FONT color="green">099</FONT>                    }<a name="line.99"></a>
<FONT color="green">100</FONT>                    if (len != mArray.length) {<a name="line.100"></a>
<FONT color="green">101</FONT>                            T[] newArr = newArray(len);<a name="line.101"></a>
<FONT color="green">102</FONT>                            System.arraycopy(mArray, 0, newArr, 0, len);<a name="line.102"></a>
<FONT color="green">103</FONT>                            mArray = newArr;<a name="line.103"></a>
<FONT color="green">104</FONT>                    }<a name="line.104"></a>
<FONT color="green">105</FONT>            }<a name="line.105"></a>
<FONT color="green">106</FONT>    <a name="line.106"></a>
<FONT color="green">107</FONT>            @Override<a name="line.107"></a>
<FONT color="green">108</FONT>            @SuppressWarnings("unchecked")<a name="line.108"></a>
<FONT color="green">109</FONT>            public &lt;TT&gt; TT[] toArray(TT[] a) {<a name="line.109"></a>
<FONT color="green">110</FONT>                    int size = length();<a name="line.110"></a>
<FONT color="green">111</FONT>            if (a.length &lt; size) {<a name="line.111"></a>
<FONT color="green">112</FONT>                a = (TT[])java.lang.reflect.Array.newInstance(a.getClass().getComponentType(), size);               <a name="line.112"></a>
<FONT color="green">113</FONT>            }<a name="line.113"></a>
<FONT color="green">114</FONT>            System.arraycopy(mArray, 0, a, 0, size);<a name="line.114"></a>
<FONT color="green">115</FONT>            if (a.length &gt; size) {<a name="line.115"></a>
<FONT color="green">116</FONT>                a[size] = null;             <a name="line.116"></a>
<FONT color="green">117</FONT>            }<a name="line.117"></a>
<FONT color="green">118</FONT>            return a;<a name="line.118"></a>
<FONT color="green">119</FONT>            }<a name="line.119"></a>
<FONT color="green">120</FONT>            <a name="line.120"></a>
<FONT color="green">121</FONT>            @Override<a name="line.121"></a>
<FONT color="green">122</FONT>            @SuppressWarnings("unchecked")<a name="line.122"></a>
<FONT color="green">123</FONT>            public &lt;TT&gt; TT[] toArray(Class&lt;TT&gt; componentType) {<a name="line.123"></a>
<FONT color="green">124</FONT>                    int size = length();<a name="line.124"></a>
<FONT color="green">125</FONT>            TT[] arr = (TT[])java.lang.reflect.Array.newInstance(componentType, size);              <a name="line.125"></a>
<FONT color="green">126</FONT>            System.arraycopy(mArray, 0, arr, 0, size);<a name="line.126"></a>
<FONT color="green">127</FONT>            return arr;<a name="line.127"></a>
<FONT color="green">128</FONT>            }<a name="line.128"></a>
<FONT color="green">129</FONT>            <a name="line.129"></a>
<FONT color="green">130</FONT>            @SuppressWarnings("unchecked")<a name="line.130"></a>
<FONT color="green">131</FONT>            public void copyFrom(GenericArray&lt;? extends T&gt; src, int srcPos, int dstPos, int length) {<a name="line.131"></a>
<FONT color="green">132</FONT>                    if (src instanceof GenericDynamicArray) {<a name="line.132"></a>
<FONT color="green">133</FONT>                            copyFrom((GenericDynamicArray&lt;T&gt;)src, srcPos, dstPos, length);<a name="line.133"></a>
<FONT color="green">134</FONT>                    }<a name="line.134"></a>
<FONT color="green">135</FONT>                    else {<a name="line.135"></a>
<FONT color="green">136</FONT>                            src.copyTo(this, srcPos, dstPos, length);<a name="line.136"></a>
<FONT color="green">137</FONT>                    }<a name="line.137"></a>
<FONT color="green">138</FONT>            }<a name="line.138"></a>
<FONT color="green">139</FONT>            @SuppressWarnings("unchecked")<a name="line.139"></a>
<FONT color="green">140</FONT>            public void copyTo(GenericArray&lt;? super T&gt; dst, int srcPos, int dstPos, int length) {<a name="line.140"></a>
<FONT color="green">141</FONT>                    if (dst instanceof GenericDynamicArray) {<a name="line.141"></a>
<FONT color="green">142</FONT>                            copyTo((GenericDynamicArray&lt;T&gt;)dst, srcPos, dstPos, length);<a name="line.142"></a>
<FONT color="green">143</FONT>                    }<a name="line.143"></a>
<FONT color="green">144</FONT>                    else {<a name="line.144"></a>
<FONT color="green">145</FONT>                            dst.set(dstPos, mArray, srcPos, length);<a name="line.145"></a>
<FONT color="green">146</FONT>                    }<a name="line.146"></a>
<FONT color="green">147</FONT>            }       <a name="line.147"></a>
<FONT color="green">148</FONT>    <a name="line.148"></a>
<FONT color="green">149</FONT>            public void copyFrom(GenericDynamicArray&lt;? extends T&gt; src, int srcPos, int dstPos, int length) {<a name="line.149"></a>
<FONT color="green">150</FONT>                    set(dstPos, src.mArray, srcPos, length);<a name="line.150"></a>
<FONT color="green">151</FONT>            }<a name="line.151"></a>
<FONT color="green">152</FONT>            public void copyTo(GenericDynamicArray&lt;? super T&gt; dst, int srcPos, int dstPos, int length) {<a name="line.152"></a>
<FONT color="green">153</FONT>                    dst.set(dstPos, mArray, srcPos, length);<a name="line.153"></a>
<FONT color="green">154</FONT>            }<a name="line.154"></a>
<FONT color="green">155</FONT>            <a name="line.155"></a>
<FONT color="green">156</FONT>            public void set(int offset, T[] arr, int srcOffset, int length) throws IndexOutOfBoundsException {<a name="line.156"></a>
<FONT color="green">157</FONT>                    if (offset &lt; 0) throw new IllegalArgumentException("illegal negative offset: " + offset);<a name="line.157"></a>
<FONT color="green">158</FONT>                    if (srcOffset &lt; 0) throw new IllegalArgumentException("illegal negative src offset: " + srcOffset);<a name="line.158"></a>
<FONT color="green">159</FONT>                    if (length &lt; 0) throw new IllegalArgumentException("illegal negative length: " + length);<a name="line.159"></a>
<FONT color="green">160</FONT>                    if ((srcOffset + length) &gt; arr.length) {<a name="line.160"></a>
<FONT color="green">161</FONT>                            throw new IndexOutOfBoundsException(<a name="line.161"></a>
<FONT color="green">162</FONT>                                            "not enough source entries: " + <a name="line.162"></a>
<FONT color="green">163</FONT>                                            srcOffset + " + " + length + " &gt; " + arr.length<a name="line.163"></a>
<FONT color="green">164</FONT>                            );<a name="line.164"></a>
<FONT color="green">165</FONT>                    }<a name="line.165"></a>
<FONT color="green">166</FONT>                    ensureCapacity(offset + length);<a name="line.166"></a>
<FONT color="green">167</FONT>                    System.arraycopy(arr, srcOffset, mArray, offset, length);<a name="line.167"></a>
<FONT color="green">168</FONT>                    mLength = Math.max(offset + length, mLength);<a name="line.168"></a>
<FONT color="green">169</FONT>            }<a name="line.169"></a>
<FONT color="green">170</FONT>    <a name="line.170"></a>
<FONT color="green">171</FONT>            public void removeLast() {<a name="line.171"></a>
<FONT color="green">172</FONT>                    removeLast(1);<a name="line.172"></a>
<FONT color="green">173</FONT>            }<a name="line.173"></a>
<FONT color="green">174</FONT>            public void removeLast(int len) {<a name="line.174"></a>
<FONT color="green">175</FONT>                    if (mLength - len &lt; 0) {<a name="line.175"></a>
<FONT color="green">176</FONT>                            throw new IndexOutOfBoundsException(<a name="line.176"></a>
<FONT color="green">177</FONT>                                            "cannot remove last " + len + <a name="line.177"></a>
<FONT color="green">178</FONT>                                            " entries, there are only " + mLength                                   <a name="line.178"></a>
<FONT color="green">179</FONT>                            );<a name="line.179"></a>
<FONT color="green">180</FONT>                    }<a name="line.180"></a>
<FONT color="green">181</FONT>                    mLength -= len;<a name="line.181"></a>
<FONT color="green">182</FONT>                    for (int ii = 0; ii &lt; len; ii++) {<a name="line.182"></a>
<FONT color="green">183</FONT>                            mArray[mLength + ii] = null;<a name="line.183"></a>
<FONT color="green">184</FONT>                    }<a name="line.184"></a>
<FONT color="green">185</FONT>            }<a name="line.185"></a>
<FONT color="green">186</FONT>            @Override<a name="line.186"></a>
<FONT color="green">187</FONT>            public T remove(int index) {<a name="line.187"></a>
<FONT color="green">188</FONT>                    if (index == length() - 1) {<a name="line.188"></a>
<FONT color="green">189</FONT>                            T last = last();<a name="line.189"></a>
<FONT color="green">190</FONT>                            removeLast();<a name="line.190"></a>
<FONT color="green">191</FONT>                            return last;<a name="line.191"></a>
<FONT color="green">192</FONT>                    }<a name="line.192"></a>
<FONT color="green">193</FONT>                    return super.remove(index);<a name="line.193"></a>
<FONT color="green">194</FONT>            }<a name="line.194"></a>
<FONT color="green">195</FONT>    <a name="line.195"></a>
<FONT color="green">196</FONT>            public void clear() {<a name="line.196"></a>
<FONT color="green">197</FONT>                    mArray = newArray(Math.max(mArray.length / 2, DEFAULT_CAPACITY));<a name="line.197"></a>
<FONT color="green">198</FONT>                    mLength = 0;<a name="line.198"></a>
<FONT color="green">199</FONT>            }<a name="line.199"></a>
<FONT color="green">200</FONT>    <a name="line.200"></a>
<FONT color="green">201</FONT>            @Override<a name="line.201"></a>
<FONT color="green">202</FONT>            public T get(int index) throws IndexOutOfBoundsException {<a name="line.202"></a>
<FONT color="green">203</FONT>                    if (/* index &lt; 0 ||*/ index &gt;= mLength) {<a name="line.203"></a>
<FONT color="green">204</FONT>                            //index &lt; 0 is thrown anyway by array access below<a name="line.204"></a>
<FONT color="green">205</FONT>                            throw new IndexOutOfBoundsException(<a name="line.205"></a>
<FONT color="green">206</FONT>                                    "index " + index + " not in[0, " + (mLength - 1) + "]"<a name="line.206"></a>
<FONT color="green">207</FONT>                            ); <a name="line.207"></a>
<FONT color="green">208</FONT>                    }<a name="line.208"></a>
<FONT color="green">209</FONT>                    return mArray[index];<a name="line.209"></a>
<FONT color="green">210</FONT>            }<a name="line.210"></a>
<FONT color="green">211</FONT>            <a name="line.211"></a>
<FONT color="green">212</FONT>            @Override<a name="line.212"></a>
<FONT color="green">213</FONT>            public T first() throws IndexOutOfBoundsException {<a name="line.213"></a>
<FONT color="green">214</FONT>                    if (mLength &gt; 0) {<a name="line.214"></a>
<FONT color="green">215</FONT>                            return mArray[0];<a name="line.215"></a>
<FONT color="green">216</FONT>                    }<a name="line.216"></a>
<FONT color="green">217</FONT>                    throw new IndexOutOfBoundsException(<a name="line.217"></a>
<FONT color="green">218</FONT>                            "empty array"<a name="line.218"></a>
<FONT color="green">219</FONT>                    ); <a name="line.219"></a>
<FONT color="green">220</FONT>            }<a name="line.220"></a>
<FONT color="green">221</FONT>            <a name="line.221"></a>
<FONT color="green">222</FONT>            @Override<a name="line.222"></a>
<FONT color="green">223</FONT>            public T last() throws IndexOutOfBoundsException {<a name="line.223"></a>
<FONT color="green">224</FONT>                    if (mLength &gt; 0) {<a name="line.224"></a>
<FONT color="green">225</FONT>                            return mArray[mLength - 1];<a name="line.225"></a>
<FONT color="green">226</FONT>                    }<a name="line.226"></a>
<FONT color="green">227</FONT>                    throw new IndexOutOfBoundsException(<a name="line.227"></a>
<FONT color="green">228</FONT>                            "empty array"<a name="line.228"></a>
<FONT color="green">229</FONT>                    ); <a name="line.229"></a>
<FONT color="green">230</FONT>            }<a name="line.230"></a>
<FONT color="green">231</FONT>    <a name="line.231"></a>
<FONT color="green">232</FONT>            @Override<a name="line.232"></a>
<FONT color="green">233</FONT>            public T set(int index, T element) {<a name="line.233"></a>
<FONT color="green">234</FONT>                    T old;<a name="line.234"></a>
<FONT color="green">235</FONT>                    if (index &lt; mArray.length) {<a name="line.235"></a>
<FONT color="green">236</FONT>                            old = mArray[index];<a name="line.236"></a>
<FONT color="green">237</FONT>                    }<a name="line.237"></a>
<FONT color="green">238</FONT>                    else {<a name="line.238"></a>
<FONT color="green">239</FONT>                            if (element == null) return null;<a name="line.239"></a>
<FONT color="green">240</FONT>                            old = null;                     <a name="line.240"></a>
<FONT color="green">241</FONT>                            ensureCapacity(index + 1);<a name="line.241"></a>
<FONT color="green">242</FONT>                    }<a name="line.242"></a>
<FONT color="green">243</FONT>                    mArray[index] = element;<a name="line.243"></a>
<FONT color="green">244</FONT>                    if (index &gt;= mLength) {<a name="line.244"></a>
<FONT color="green">245</FONT>                            mLength = index + 1;                    <a name="line.245"></a>
<FONT color="green">246</FONT>                    }<a name="line.246"></a>
<FONT color="green">247</FONT>                    return old;<a name="line.247"></a>
<FONT color="green">248</FONT>            }<a name="line.248"></a>
<FONT color="green">249</FONT>            @SuppressWarnings("unchecked")<a name="line.249"></a>
<FONT color="green">250</FONT>            public void set(int offset, Iterable&lt;? extends T&gt; it) {<a name="line.250"></a>
<FONT color="green">251</FONT>                    if (it instanceof GenericArray) {<a name="line.251"></a>
<FONT color="green">252</FONT>                            copyFrom((GenericArray&lt;T&gt;)it, 0, offset, ((GenericArray&lt;T&gt;)it).length());<a name="line.252"></a>
<FONT color="green">253</FONT>                    }<a name="line.253"></a>
<FONT color="green">254</FONT>                    else {<a name="line.254"></a>
<FONT color="green">255</FONT>                            for (T el : it) {<a name="line.255"></a>
<FONT color="green">256</FONT>                                    set(offset++, el);<a name="line.256"></a>
<FONT color="green">257</FONT>                            }<a name="line.257"></a>
<FONT color="green">258</FONT>                mLength = Math.max(offset, mLength);<a name="line.258"></a>
<FONT color="green">259</FONT>                    }<a name="line.259"></a>
<FONT color="green">260</FONT>            }<a name="line.260"></a>
<FONT color="green">261</FONT>            <a name="line.261"></a>
<FONT color="green">262</FONT>            protected void ensureCapacity(int capacity) {<a name="line.262"></a>
<FONT color="green">263</FONT>                    if (capacity &gt;= mArray.length) {<a name="line.263"></a>
<FONT color="green">264</FONT>                            int newSize = Math.max(mArray.length * 2, capacity);<a name="line.264"></a>
<FONT color="green">265</FONT>                            T[] newArr = newArray(newSize);<a name="line.265"></a>
<FONT color="green">266</FONT>                            System.arraycopy(mArray, 0, newArr, 0, mLength);<a name="line.266"></a>
<FONT color="green">267</FONT>                            mArray = newArr;<a name="line.267"></a>
<FONT color="green">268</FONT>                    }               <a name="line.268"></a>
<FONT color="green">269</FONT>            }<a name="line.269"></a>
<FONT color="green">270</FONT>            <a name="line.270"></a>
<FONT color="green">271</FONT>            @Override<a name="line.271"></a>
<FONT color="green">272</FONT>            public void swap(int indexA, int indexB) {<a name="line.272"></a>
<FONT color="green">273</FONT>                    if (Math.min(indexA, indexB) &lt; 0 || Math.max(indexA, indexB) &gt;= mLength) {<a name="line.273"></a>
<FONT color="green">274</FONT>                            throw new IndexOutOfBoundsException(<a name="line.274"></a>
<FONT color="green">275</FONT>                                    "index " + indexA + " or " + indexB + <a name="line.275"></a>
<FONT color="green">276</FONT>                                    " out of bounds [0, " + (mLength - 1) + "]"                             <a name="line.276"></a>
<FONT color="green">277</FONT>                            );<a name="line.277"></a>
<FONT color="green">278</FONT>                    }<a name="line.278"></a>
<FONT color="green">279</FONT>                    T tmp = mArray[indexA];<a name="line.279"></a>
<FONT color="green">280</FONT>                    mArray[indexA] = mArray[indexB];<a name="line.280"></a>
<FONT color="green">281</FONT>                    mArray[indexB] = tmp;<a name="line.281"></a>
<FONT color="green">282</FONT>            }<a name="line.282"></a>
<FONT color="green">283</FONT>            <a name="line.283"></a>
<FONT color="green">284</FONT>            public List&lt;T&gt; subList(int fromIndex, int toIndex) {<a name="line.284"></a>
<FONT color="green">285</FONT>                    if (fromIndex &lt; 0 || toIndex &gt; length() || fromIndex &gt; toIndex) {<a name="line.285"></a>
<FONT color="green">286</FONT>                            throw new IndexOutOfBoundsException(<a name="line.286"></a>
<FONT color="green">287</FONT>                                    "[" + fromIndex + ", " + toIndex + "] out of bounds [0, " +<a name="line.287"></a>
<FONT color="green">288</FONT>                                    length() + "] or fromIndex &gt; toIndex"<a name="line.288"></a>
<FONT color="green">289</FONT>                            );<a name="line.289"></a>
<FONT color="green">290</FONT>                    }<a name="line.290"></a>
<FONT color="green">291</FONT>                    T[] arr = newArray(toIndex - fromIndex);<a name="line.291"></a>
<FONT color="green">292</FONT>                    System.arraycopy(mArray, fromIndex, arr, 0, toIndex - fromIndex);<a name="line.292"></a>
<FONT color="green">293</FONT>                    return new GenericFixSizeArray&lt;T&gt;(arr);<a name="line.293"></a>
<FONT color="green">294</FONT>            }<a name="line.294"></a>
<FONT color="green">295</FONT>            <a name="line.295"></a>
<FONT color="green">296</FONT>            @Override<a name="line.296"></a>
<FONT color="green">297</FONT>            public GenericDynamicArray&lt;T&gt; clone() {<a name="line.297"></a>
<FONT color="green">298</FONT>                    GenericDynamicArray&lt;T&gt; clone = new GenericDynamicArray&lt;T&gt;(0);<a name="line.298"></a>
<FONT color="green">299</FONT>                    clone.mArray    = mArray.clone();<a name="line.299"></a>
<FONT color="green">300</FONT>                    clone.mLength   = mLength;<a name="line.300"></a>
<FONT color="green">301</FONT>                    return clone;<a name="line.301"></a>
<FONT color="green">302</FONT>            }<a name="line.302"></a>
<FONT color="green">303</FONT>            <a name="line.303"></a>
<FONT color="green">304</FONT>            @Override<a name="line.304"></a>
<FONT color="green">305</FONT>            public String toString() {<a name="line.305"></a>
<FONT color="green">306</FONT>                    StringBuffer sb = new StringBuffer();<a name="line.306"></a>
<FONT color="green">307</FONT>                    sb.append('[');<a name="line.307"></a>
<FONT color="green">308</FONT>                    for (int ii = 0; ii &lt; mLength; ii++) {<a name="line.308"></a>
<FONT color="green">309</FONT>                            if (ii &gt; 0) sb.append(", ");<a name="line.309"></a>
<FONT color="green">310</FONT>                            sb.append(mArray[ii]);<a name="line.310"></a>
<FONT color="green">311</FONT>                    }<a name="line.311"></a>
<FONT color="green">312</FONT>                    sb.append(']');<a name="line.312"></a>
<FONT color="green">313</FONT>                    return sb.toString();<a name="line.313"></a>
<FONT color="green">314</FONT>            }<a name="line.314"></a>
<FONT color="green">315</FONT>            <a name="line.315"></a>
<FONT color="green">316</FONT>    }<a name="line.316"></a>




























































</PRE>
</BODY>
</HTML>
